#!/bin/tcsh -f
#

set path=( /bin /usr/bin /sbin /usr/sbin /usr/local/bin /usr/etc /etc )

echo " "

set count=`ps uxww | grep -v grep | grep -c XDarwin`
set count=0
if( $count != 0 ) then
  echo "XDarwin is currently running -"
  echo "please exit it before using this script"
  sleep 1
  exit 12
endif

set thisdir=`echo $0 | sed 's/InterleaveX11.command//'`

if( ! -d "$thisdir" ) then
  echo "Could not find OroborOSX's directory"
  echo "  -assuming run from command line...?"
  sleep 1
else
  cd $thisdir
endif

if( ! -d /Applications ) then
  echo "The Applications directory is missing"
  echo " -aborting attempt to set up XDarwin"
  sleep 1
  exit 10
endif

if( ! -d /Applications/XDarwin.app ) then
  echo "Cannot find the XDarwin application"
  echo " -aborting attempt to set up XDarwin"
  sleep 1
  exit 2
endif

if( ! -f /Applications/XDarwin.app/Contents/Info.plist ) then
  echo "Cannot find XDarwin's Info.plist file"
  echo " -aborting attempt to set up XDarwin"
  sleep 1
  exit 3
endif

set count=`grep -i -c nsuielement /Applications/XDarwin.app/Contents/Info.plist`

if( $count == 1 ) then
  echo "XDarwin looks like it is already"
  echo "updated for window interleaving"
  echo " -no need to do anything"
  sleep 1
  exit
endif

unsetenv sedfile
unset sedfile

set sedfile=/tmp/sedfile.$$
if( -f $sedfile ) rm -rf $sedfile
if( -f $sedfile ) set sedfile=$HOME/temporary-sedfile.$$
if( -f $sedfile ) rm -rf $sedfile
if( -f $sedfile ) then
  echo "Cannot remove old file: $sedfile"
  sleep 1
  exit 12
endif

touch $sedfile

if( ! -f $sedfile ) then
  set sedfile=$HOME/temporary-sedfile.$$
  touch $sedfile
endif

if( ! -f $sedfile) then
  echo "Failed to create file: $sedfile"
  sleep 1
  exit 13
endif

echo "s/<\/dict>/        <key>NSUIElement<\/key>\" > $sedfile
echo "        <string>1<\/string>\" >> $sedfile
echo "<\/dict>/" >> $sedfile


sudo -k

if( $#argv == 0 ) then
  echo "In order to change XDarwin"
  echo "to interleave X11 windows,"
  echo "I need Administrator access."
  echo " "
  echo "Type your password and press return"
  sudo mv /Applications/XDarwin.app/Contents/Info.plist /Applications/XDarwin.app/Contents/Info-org.plist
else
  echo $1 | sudo -p "" -S mv /Applications/XDarwin.app/Contents/Info.plist /Applications/XDarwin.app/Contents/Info-org.plist 
endif

echo " "

if( ! -f /Applications/XDarwin.app/Contents/Info-org.plist ) then
   echo "Failed to move original Info.plist."
   echo "Maybe you do not have Administrator"
   echo "privileges, or perhaps you typed the"
   echo "password incorrectly?"
   rm -rf $sedfile
   sleep 1
   exit 5
endif

unsetenv plistfile
unset plistfile

set plistfile=/tmp/Info-$$.plist
if( -f $plistfile ) rm -rf $plistfile
if( -f $plistfile ) set plistfile=$HOME/Info-temporary-$$.plist
if( -f $plistfile ) rm -rf $plistfile
if( -f $plistfile ) then
  echo "Cannot remove old file: $plistfile"
  rm -rf $sedfile
  sleep 1
  exit 14
endif

touch $plistfile
if( ! -f $plistfile ) set plistfile=$HOME/Info-temporary-$$.plist

sudo sed -f $sedfile /Applications/XDarwin.app/Contents/Info-org.plist > $plistfile

if( ! -f $plistfile ) then
  echo "Could not create file: $plistfile"
  rm -rf $sedfile
  sleep 1
  exit 15
endif

sudo mv $plistfile /Applications/XDarwin.app/Contents/Info.plist

rm -rf $sedfile

if( ! -f /Applications/XDarwin.app/Contents/Info.plist ) then
   echo "Failed to create new Info.plist..."
   sudo mv /Applications/XDarwin.app/Contents/Info-org.plist /Applications/XDarwin.app/Contents/Info.plist
   sleep 1
   exit 6
endif

set count=`grep -i -c nsuielement /Applications/XDarwin.app/Contents/Info.plist`

if( $count != 1 ) then
  echo "Something went wrong"
  echo " - failed to change XDarwin's Info.plist"
  echo "Please e-mail adrian@ic.ac.uk"
  echo "and report this error message."
  sleep 1
  exit 7
endif

echo "XDarwin successfully updated"
echo " -window interleaving now enabled"
sleep 1
